diff -ru --new-file util-linux-2.11y/mount/lomount.c util-linux-AES/mount/lomount.c
--- util-linux-2.11y/mount/lomount.c	Fri Nov  1 02:58:51 2002
+++ util-linux-AES/mount/lomount.c	Wed Feb 12 17:06:01 2003
@@ -6,6 +6,16 @@
  * - added Native Language Support
  * Sun Mar 21 1999 - Arnaldo Carvalho de Melo <acme@conectiva.com.br>
  * - fixed strerr(errno) in gettext calls
+ * 2000-09-24 Marc Mutz <Marc@Mutz.com>
+ * - added long option names and the --pass-fd option to pass
+ *   passphrases via fd's to losetup/mount. Used for encryption in
+ *   non-interactive environments. The idea behind xgetpass() is stolen
+ *   from GnuPG, v.1.0.3 (http://www.gnupg.org/).
+ * 2003-03-07 Fruhwirth Clemens <clemens@endorphin.org>
+ * - added/merged crypto support for:
+ *	- loop-AES (from Jari Ruusu <jari.ruusu@pp.inet.fi>)
+ *	- cryptoloop for 2.4.x (from kerneli.org <cryptoapi-devel@kerneli.org>)
+ * 	- cryptoloop for 2.5.x (from Fruhwirth Clemens <clemens@endorphin.org>)
  */
 
 #define PROC_DEVICES	"/proc/devices"
@@ -21,55 +31,128 @@
 #include <errno.h>
 #include <stdlib.h>
 #include <unistd.h>
+#include <pwd.h>
+#include <sys/types.h>
+#include <sys/wait.h>
+#include <limits.h>
 #include <sys/ioctl.h>
 #include <sys/stat.h>
 #include <sys/mman.h>
 #include <sys/sysmacros.h>
+#include <fcntl.h>
+#include <mntent.h>
+#include <locale.h>
 
 #include "loop.h"
 #include "lomount.h"
+#include "rmd160.h"
+#include "sha512.h"
+#include "aes.h"
 #include "xstrncpy.h"
 #include "nls.h"
 
+#ifndef LO_CRYPT_CRYPTOAPI
+#define LO_CRYPT_CRYPTOAPI 18
+#endif
+#ifndef LO_CRYPT_NONE
+#define LO_CRYPT_NONE 0
+#endif
+#ifndef LO_CRYPT_XOR
+#define LO_CRYPT_XOR 1
+#endif
+#ifndef LO_CRYPT_DES
+#define LO_CRYPT_DES 2
+#endif
+#ifndef LO_CRYPT_FISH2
+#define LO_CRYPT_FISH2 3
+#endif
+#ifndef LO_CRYPT_BLOW
+#define LO_CRYPT_BLOW 4
+#endif
+#ifndef LO_CRYPT_CAST128
+#define LO_CRYPT_CAST128 5
+#endif
+#ifndef LO_CRYPT_IDEA
+#define LO_CRYPT_IDEA 6
+#endif
+#ifndef LO_CRYPT_SERPENT
+#define LO_CRYPT_SERPENT 7
+#endif
+#ifndef LO_CRYPT_MARS
+#define LO_CRYPT_MARS 8
+#endif
+#ifndef LO_CRYPT_RC6
+#define LO_CRYPT_RC6 11
+#endif
+#ifndef LO_CRYPT_3DES
+#define LO_CRYPT_3DES 12
+#endif
+#ifndef LO_CRYPT_DFC
+#define LO_CRYPT_DFC 15
+#endif
+#ifndef LO_CRYPT_RIJNDAEL
+#define LO_CRYPT_RIJNDAEL 16
+#endif
+
+#if !defined(LOOP_PASSWORD_MIN_LENGTH)
+# define  LOOP_PASSWORD_MIN_LENGTH   20
+#endif
+
+
 extern int verbose;
 extern char *xstrdup (const char *s);	/* not: #include "sundries.h" */
 extern void error (const char *fmt, ...);	/* idem */
+extern void show_all_loops(void);
+extern int read_options_from_fstab(char *, char **, char **, char **, char **, char **,
+			    char **, char **, char **, char **);
+
+// CryptoAPI cipher struct
+
+struct cipher_info
+{
+	const char *name;
+	int blocksize;
+	int keysize_mask;
+	int ivsize;
+	int key_schedule_size;
+};
+
+static int set_loop_passwd(struct loop_info *_loopinfo, int pfd, int keysz,
+			   const char *phash_name, const char *encryption, 
+			   int fd, int ffd, char *passIterThousands, char *gpgHomeDir,
+			   char *gpgKeyFile, int passAskTwice, char *loInitValue,
+			   char *passSeedString);
+static int get_cipher_info(const char *name, struct cipher_info *res);
+static int name_to_id(const char *name);
+#ifdef MAIN
+static char *id_to_name(int id);
+#endif
+ 
 
 #ifdef LOOP_SET_FD
 struct crypt_type_struct {
 	int id;
 	char *name;
+	int keylength;
 } crypt_type_tbl[] = {
-	{ LO_CRYPT_NONE, "no" },
-	{ LO_CRYPT_NONE, "none" },
-	{ LO_CRYPT_XOR, "xor" },
-	{ LO_CRYPT_DES, "DES" },
-	{ -1, NULL   }
+        { LO_CRYPT_NONE, "none", 0 },
+        { LO_CRYPT_NONE, "no", 0 },
+        { LO_CRYPT_XOR, "xor", 0 },
+        { LO_CRYPT_DES, "des", 8 },
+        { LO_CRYPT_FISH2, "twofish", 20 },
+        { LO_CRYPT_BLOW, "blowfish", 20 },
+        { LO_CRYPT_CAST128, "cast", 16 },
+        { LO_CRYPT_SERPENT, "serpent", 16 },
+        { LO_CRYPT_MARS, "mars", 16 },
+        { LO_CRYPT_RC6, "rc6", 16 },
+        { LO_CRYPT_3DES, "des-ede3", 24 },
+        { LO_CRYPT_DFC, "dfc", 16 },
+        { LO_CRYPT_IDEA, "idea", 16 },
+        { LO_CRYPT_RIJNDAEL, "rijndael", 16 },
+	{ -1, NULL,0   }
 };
 
-static int 
-crypt_type (const char *name) {
-	int i;
-
-	if (name) {
-		for (i = 0; crypt_type_tbl[i].id != -1; i++)
-			if (!strcasecmp (name, crypt_type_tbl[i].name))
-				return crypt_type_tbl[i].id;
-	}
-	return -1;
-}
-
 #ifdef MAIN
-static char *
-crypt_name (int id) {
-	int i;
-
-	for (i = 0; crypt_type_tbl[i].id != -1; i++)
-		if (id == crypt_type_tbl[i].id)
-			return crypt_type_tbl[i].name;
-	return "undefined";
-}
-
 static int
 show_loop (char *device) {
 	struct loop_info loopinfo;
@@ -91,40 +174,13 @@
 	printf (_("%s: [%04x]:%ld (%s) offset %d, %s encryption\n"),
 		device, loopinfo.lo_device, loopinfo.lo_inode,
 		loopinfo.lo_name, loopinfo.lo_offset,
-		crypt_name (loopinfo.lo_encrypt_type));
+		id_to_name(loopinfo.lo_encrypt_type));
 	close (fd);
 
 	return 0;
 }
 #endif
 
-int
-is_loop_device (const char *device) {
-	struct stat statbuf;
-	int loopmajor;
-#if 1
-	loopmajor = 7;
-#else
-	FILE *procdev;
-	char line[100], *cp;
-
-	loopmajor = 0;
-	if ((procdev = fopen(PROC_DEVICES, "r")) != NULL) {
-		while (fgets (line, sizeof(line), procdev)) {
-			if ((cp = strstr (line, " loop\n")) != NULL) {
-				*cp='\0';
-				loopmajor=atoi(line);
-				break;
-			}
-		}
-		fclose(procdev);
-	}
-#endif
-	return (loopmajor && stat(device, &statbuf) == 0 &&
-		S_ISBLK(statbuf.st_mode) &&
-		major(statbuf.st_rdev) == loopmajor);
-}
-
 #define SIZE(a) (sizeof(a)/sizeof(a[0]))
 
 char *
@@ -184,24 +240,262 @@
 		error(_(
 		    "mount: Could not find any loop device, and, according to %s,\n"
 		    "       this kernel does not know about the loop device.\n"
-		    "       (If so, then recompile or `insmod loop.o'.)"),
+		    "       (If so, then recompile or `modprobe loop'.)"),
 		      PROC_DEVICES);
 	    else
 		error(_(
 		    "mount: Could not find any loop device. Maybe this kernel does not know\n"
-		    "       about the loop device (then recompile or `insmod loop.o'), or\n"
+		    "       about the loop device (then recompile or `modprobe loop'), or\n"
 		    "       maybe /dev/loop# has the wrong major number?"));
 	} else
 		error(_("mount: could not find any free loop device"));
 	return 0;
 }
 
+static int rd_wr_retry(int fd, char *buf, int cnt, int w)
+{
+ 	int x, y, z;
+
+	x = 0;
+	while(x < cnt) {
+	        y = cnt - x;
+	        if(w) {
+	                z = write(fd, buf + x, y);
+	        } else {
+	                z = read(fd, buf + x, y);
+	                if (!z) return x;
+	        }
+	        if(z < 0) {
+	                if ((errno == EAGAIN) || (errno == ENOMEM) || (errno == ERESTART) || (errno == EINTR)) {
+	                        continue;
+	                }
+	                return x;
+	        }
+	        x += z;
+	}
+	return x;
+}
+ 
+static char *get_FD_pass(int fd)
+{
+ 	char *p = NULL;
+ 	int x = 0, y = 0;
+
+	do {
+	    	if(y >= (x - 1)) {
+	    	        x += 128; 
+	    	        if(!(p = realloc(p, x))) break;
+	    	}
+	    	if(rd_wr_retry(fd, p + y, 1, 0) != 1) break;
+	    	if((p[y] == '\n') || !p[y]) break;
+	    	y++;
+	} while(1); 
+	if(p) p[y] = 0;
+	return p;
+}
+
+static char *do_GPG_pipe(char *pass, char *gpgHomeDir, char *gpgKeyFile)
+{
+ 	int	x, pfdi[2], pfdo[2];
+ 	char	str[10], *a[16], *e[2], *h;
+ 	pid_t   gpid;
+ 	struct passwd *p;
+
+	if((getuid() == 0) && gpgHomeDir && gpgHomeDir[0]) {
+	        h = gpgHomeDir;
+	} else {
+	        if(!(p = getpwuid(getuid()))) {
+	                nomem1:
+	                fprintf(stderr, _("Error: Unable to allocate memory\n"));
+	                return NULL;
+	        }
+	        h = p->pw_dir;
+	}
+	if(!(e[0] = malloc(strlen(h) + 6))) goto nomem1;
+	sprintf(e[0], "HOME=%s", h);
+	e[1] = 0;
+
+	if(pipe(&pfdi[0])) {
+	        nomem2:
+	        free(e[0]);
+	        goto nomem1;
+	}
+	if(pipe(&pfdo[0])) {
+	        close(pfdi[0]);
+	        close(pfdi[1]);
+	        goto nomem2;   
+	}
+
+	/*
+	 * When this code is run as part of losetup, normal read permissions
+	 * affect the open() below because losetup is not setuid-root.
+	 *
+	 * When this code is run as part of mount, only root can set
+	 * 'gpgKeyFile' and as such, only root can decide what file is opened
+	 * below. However, since mount is usually setuid-root all non-root   
+	 * users can also open() the file too, but that file's contents are  
+	 * only piped to gpg. This readable-for-all is intended behaviour,   
+	 * and is very useful in situations where non-root users mount loop  
+	 * devices with their own gpg private key, and yet don't have access 
+	 * to the actual key used to encrypt loop device.
+	 */
+	if((x = open(gpgKeyFile, O_RDONLY)) == -1) {
+	        fprintf(stderr, _("Error: unable to open %s for reading\n"), gpgKeyFile);
+	        free(e[0]);
+	        close(pfdo[0]);
+	        close(pfdo[1]);
+	        close(pfdi[0]);
+ 	        close(pfdi[1]);
+	        return NULL;   
+	}
+
+	sprintf(str, "%d", pfdi[0]);
+	if(!(gpid = fork())) {
+	        dup2(x, 0);   
+	        dup2(pfdo[1], 1);
+	        close(x);
+	        close(pfdi[1]);
+	        close(pfdo[0]);
+	        close(pfdo[1]);
+	        if((x = open("/dev/null", O_WRONLY)) >= 0) {
+	                dup2(x, 2);
+	                close(x);  
+	        }
+	        x = 0;
+	        a[x++] = "gpg";
+	        if(gpgHomeDir && gpgHomeDir[0]) {
+	                a[x++] = "--homedir";
+	                a[x++] = gpgHomeDir; 
+	        }
+	        a[x++] = "--options";
+	        a[x++] = "/dev/null";
+	        a[x++] = "--quiet";  
+	 	a[x++] = "--batch";  
+		a[x++] = "--no-tty"; 
+	  	a[x++] = "--passphrase-fd";
+	        a[x++] = str;
+	        a[x++] = "--decrypt";
+	  	a[x] = 0;
+	        if(getuid() != geteuid())
+	                setuid(getuid());
+	        execve("/bin/gpg", &a[0], &e[0]);
+	        execve("/usr/bin/gpg", &a[0], &e[0]);
+	        execve("/usr/local/bin/gpg", &a[0], &e[0]);
+	        exit(1);
+	}
+	free(e[0]);
+	close(x);  
+	close(pfdi[0]);
+	close(pfdo[1]);
+	if(gpid == -1) {
+	        close(pfdi[1]);
+	        close(pfdo[0]);
+	        goto nomem1;   
+	}
+
+	x = strlen(pass);
+	rd_wr_retry(pfdi[1], pass, x, 1);
+	rd_wr_retry(pfdi[1], "\n", 1, 1);
+	close(pfdi[1]);
+	memset(pass, 0, x);
+	pass = get_FD_pass(pfdo[0]);
+	close(pfdo[0]);
+	waitpid(gpid, &x, 0);
+	if(!pass) goto nomem1;
+	return pass;
+}
+
+/* */
+static char *sGetPass(int minLen, int warnLen, int passFDnumber, char *gpgHomeDir, 
+			char *gpgKeyFile, int passAskTwice, char *passSeedString)
+{
+ 	char *p, *s, *seed;
+	int i, ask2;
+
+	if(passFDnumber < 0) {
+		p = getpass(_("Password: "));
+		ask2 = passAskTwice;
+	} else {
+                p = get_FD_pass(passFDnumber);
+		ask2 = 0;
+	}
+        if(!p) goto nomem;
+	if(gpgKeyFile && gpgKeyFile[0]) {
+		if(ask2) {
+                        i = strlen(p);
+			s = malloc(i + 1);
+			if(!s) goto nomem;
+			strcpy(s, p);
+			p = getpass(_("Retype password: "));
+			if(!p) goto nomem;
+			if(strcmp(s, p)) goto compareErr;
+			memset(s, 0, i);
+			free(s);
+                        ask2 = 0;
+		}
+                p = do_GPG_pipe(p,gpgHomeDir,gpgKeyFile);
+		if(!p) return(NULL);
+		if(!p[0]) {
+                        fprintf(stderr, _("Error: gpg key file decryption failed\n"));
+			return(NULL);
+		}
+	}
+        i = strlen(p);
+	if(i < minLen) {
+		fprintf(stderr, _("Error: Password must be at least %d characters.\n"), minLen);
+		return(NULL);
+	}
+        seed = passSeedString;
+	if(!seed) seed = "";
+	s = malloc(i + strlen(seed) + 1);
+	if(!s) {
+                nomem:
+		fprintf(stderr, _("Error: Unable to allocate memory\n"));
+		return(NULL);
+	}
+        strcpy(s, p);
+	memset(p, 0, i);
+	if(ask2) {
+                p = getpass(_("Retype password: "));
+		if(!p) goto nomem;
+		if(strcmp(s, p)) {
+		        compareErr:
+		        fprintf(stderr, _("Error: Passwords are not identical\n"));
+		        return(NULL);
+		}
+		memset(p, 0, i);
+	}
+	if(i < warnLen) {
+	        fprintf(stderr,
+	              _("\n"
+		        "WARNING - WARNING - WARNING - WARNING - WARNING - WARNING - WARNING\n" 
+		        "\n" 
+	 		"Passwords shorter than %d characters are considered too short and insecure.\n"
+	                "Use of rmd160 password hash permits use of such short passwords for\n"
+	                "compatibility with other systems that do not enforce minimum length.\n"
+	                "Hopefully this message is annoying enough that you discontinue using such\n"
+	        	"short passwords.\n"
+		        "\n"
+		        "WARNING - WARNING - WARNING - WARNING - WARNING - WARNING - WARNING\n"
+		        "\n")
+	 		, LOOP_PASSWORD_MIN_LENGTH);
+	}
+	strcat(s, seed);
+	return(s);
+}
+
+
+
+
 int
 set_loop (const char *device, const char *file, int offset,
-	  const char *encryption, int *loopro) {
+	  const char *encryption, int pfd, int keysz, int *loopro, 
+	  const char *phash_name, const char *blockmode, char *passIterThousands, 
+	  char *gpgHomeDir, char *gpgKeyFile, int passAskTwice, char *loInitValue,
+	  char *passSeedString)
+{
 	struct loop_info loopinfo;
-	int fd, ffd, mode, i;
-	char *pass;
+	int fd, ffd, mode;
 
 	mode = (*loopro ? O_RDONLY : O_RDWR);
 	if ((ffd = open (file, mode)) < 0) {
@@ -219,13 +513,10 @@
 	*loopro = (mode == O_RDONLY);
 
 	memset (&loopinfo, 0, sizeof (loopinfo));
-	xstrncpy (loopinfo.lo_name, file, LO_NAME_SIZE);
-	if (encryption && (loopinfo.lo_encrypt_type = crypt_type (encryption))
-	    < 0) {
-		fprintf (stderr, _("Unsupported encryption type %s\n"),
-			 encryption);
-		return 1;
-	}
+	snprintf(loopinfo.lo_name, sizeof(loopinfo.lo_name),
+		 "%s-%s", encryption, blockmode);
+	loopinfo.lo_name[LO_NAME_SIZE - 1] = 0;
+	loopinfo.lo_encrypt_type = LO_CRYPT_CRYPTOAPI;
 	loopinfo.lo_offset = offset;
 
 #ifdef MCL_FUTURE  
@@ -241,24 +532,377 @@
 	}
 #endif
 
-	switch (loopinfo.lo_encrypt_type) {
-	case LO_CRYPT_NONE:
-		loopinfo.lo_encrypt_key_size = 0;
-		break;
+        if(loInitValue) {
+		/* cipher modules are free to do whatever they want with this value */
+		int lo_init = 0;
+		sscanf(loInitValue, "%d", &lo_init);
+		loopinfo.lo_init[0] = lo_init;
+	}
+
+	if (ioctl (fd, LOOP_SET_FD, ffd) < 0) {
+		perror ("ioctl: LOOP_SET_FD");
+		return 1;
+	}
+
+	set_loop_passwd(&loopinfo, pfd, keysz, phash_name, encryption, fd, 
+			ffd, passIterThousands, gpgHomeDir, gpgKeyFile, 
+			passAskTwice, loInitValue, passSeedString);
+
+	if (ioctl (fd, LOOP_SET_STATUS, &loopinfo) < 0) {
+		/* Try again with old-style LO_CRYPT_XX if
+                   new-style LO_CRYPT_CRYPTOAPI ioctl didn't work */
+		strncpy (loopinfo.lo_name, file, LO_NAME_SIZE);
+		loopinfo.lo_name[LO_NAME_SIZE - 1] = 0;
+		loopinfo.lo_encrypt_type = name_to_id (encryption);
+
+		set_loop_passwd(&loopinfo, pfd, keysz, phash_name, encryption, fd, 
+				ffd, passIterThousands, gpgHomeDir, gpgKeyFile, 
+				passAskTwice, loInitValue, passSeedString);
+
+		if (ioctl (fd, LOOP_SET_STATUS, &loopinfo) < 0) {
+			error("The cipher does not exist, or a cipher module "
+			      "needs to be loaded into the kernel");
+			perror ("ioctl: LOOP_SET_STATUS");
+			(void) ioctl (fd, LOOP_CLR_FD, 0);
+			return 1;
+		}
+	}
+	close (fd);
+	close (ffd);
+	if (verbose > 1)
+		printf(_("set_loop(%s,%s,%d): success\n"),
+		       device, file, offset);
+	return 0;
+}
+
+
+
+typedef int (*phash_func_t)(char dest[LO_KEY_SIZE], const char src[], size_t src_len);
+
+#define PASSWDBUFFLEN 130
+
+static int
+phash_rmd160old (char dest[LO_KEY_SIZE], const char src[], size_t src_len)
+{
+  char tmp[PASSWDBUFFLEN] = { 'A', 0, };
+  char key[RMD160_HASH_SIZE * 2] = { 0, };
+
+  strncpy (tmp + 1, src, PASSWDBUFFLEN - 1);
+  tmp[PASSWDBUFFLEN - 1] = '\0';
+  
+  rmd160_hash_buffer(key, src, src_len);
+  rmd160_hash_buffer(key + RMD160_HASH_SIZE, tmp, src_len + 1 /* dangerous! */);
+
+  memcpy (dest, key, LO_KEY_SIZE);
+
+  return 0;
+}
+
+static int
+phash_sha256 (char dest[LO_KEY_SIZE], const char src[], size_t src_len)
+{
+  memset (dest, 0, LO_KEY_SIZE);
+  sha256_hash_buffer ((char *) src, src_len, dest, LO_KEY_SIZE);
+  return 0;
+}
+
+static int
+phash_sha384 (char dest[LO_KEY_SIZE], const char src[], size_t src_len)
+{
+  memset (dest, 0, LO_KEY_SIZE);
+  sha384_hash_buffer ((char *) src, src_len, dest, LO_KEY_SIZE);
+  return 0;
+}
+
+static int
+phash_sha512 (char dest[LO_KEY_SIZE], const char src[], size_t src_len)
+{
+  memset (dest, 0, LO_KEY_SIZE);
+  sha512_hash_buffer ((char *) src, src_len, dest, LO_KEY_SIZE);
+  return 0;
+}
+
+static int
+phash_default (char dest[LO_KEY_SIZE], const char src[], size_t src_len)
+{
+  fprintf (stderr, "unknown hash type requested\n");
+  return 1;
+}
+
+static int 
+phash_hexconv(char *keyBuf, const char *keyStr, size_t src_len)
+{
+ 	register int	x, y, z;
+ 	char        	*kp;
+	int 		bufSize = LO_KEY_SIZE;
+	/*
+	 *  Preprocess the key. Uses only 6 bits of each character.
+	 */
+	printf("PANIC! %s\n",keyStr);
+	for(x = 0; x < bufSize; x++) {
+	        keyBuf[x] = 0;
+	}
+	kp = (char *)keyStr;
+	for(x = 0; x < (bufSize * 8); x += 6) {
+	        if(!(*kp)) kp = (char *)keyStr;		// rewind
+	        y = *kp++;
+                if((y >= '0') && (y <= '9')) y -= '0';
+                else if((y >= 'A') && (y <= 'Z')) y -= ('A' - 10);
+                else if((y >= 'a') && (y <= 'z')) y -= ('a' - 36);
+                else if((y == '.') || (y == '/')) y += (62 - '.');
+                else return(0);   /* invalid character */
+	        z = x >> 3;
+                if(z < bufSize) {
+                        keyBuf[z] |= y << (x & 7);
+                }
+                z++;
+                if(z < bufSize) {
+                        keyBuf[z] |= y >> (8 - (x & 7));
+                }
+	}
+        return(1);   /* ok */
+}
+
+static phash_func_t 
+phash_lookup (const char phash_name[])
+{
+  struct {
+    const char *name;
+    phash_func_t func;
+  } func_table[] = {
+    {"rmd160old", phash_rmd160old },
+    {"sha256",    phash_sha256 },
+    {"sha384",    phash_sha384 },
+    {"sha512",    phash_sha512 },
+    {"hexconv",  phash_hexconv },
+    { 0, phash_default }
+  }, *p = func_table;
+
+  for (; p->name; p++)
+    if (!strcmp (phash_name, p->name))
+      break;
+  
+  return p->func;
+}
+
+static int default_keysize_for_cipher(int encrypt_type)
+{
+	int keylength=0,i;
+	for(i=0; crypt_type_tbl[i].id != -1; i++){
+	         if(encrypt_type == crypt_type_tbl[i].id){
+		         keylength = crypt_type_tbl[i].keylength;
+			 break;
+		 }
+	}
+	return keylength;
+}
+
+static int prepare_passwd(char *src, int srcsz, char *dst, int dstsz, const char *phash_name, char *passIterThousands)
+{
+	int ret;
+	int (*hashFunc)(char [], const char [], size_t);
+
+	if(phash_name)
+		hashFunc = phash_lookup (phash_name);
+	else
+	{	hashFunc = phash_sha256;
+		if(dstsz >= 24) hashFunc = phash_sha384;
+		if(dstsz >= 32) hashFunc = phash_sha512;
+	}
+	ret = hashFunc(dst,src,srcsz);
+	if(ret != 0) return ret;
+	if(passIterThousands) {
+		aes_context ctx;
+		unsigned long iter = 0;
+		unsigned char tempkey[32];
+		/*
+                 * Set up AES-256 encryption key using same password and hash function
+                 * as before but with password bit 0 flipped before hashing. That key
+                 * is then used to encrypt actual loop key 'itercountk' thousand times.
+                 */
+                src[0] ^= 1;
+                (*hashFunc)(&tempkey[0], src, srcsz);
+                aes_set_key(&ctx, &tempkey[0], 32, 0);
+                sscanf(passIterThousands, "%lu", &iter);
+                iter *= 1000;
+                while(iter > 0) {
+                	/* encrypt both 128bit blocks with AES-256 */
+                        aes_encrypt(&ctx, dst, dst);
+                        aes_encrypt(&ctx, dst+16, dst+16);
+                        /* exchange upper half of first block with lower half of second block */
+                        memcpy(&tempkey[0], dst+8, 8);
+                        memcpy(dst+8,dst+16, 8);
+                        memcpy(dst+16, &tempkey[0], 8);
+                        iter--;
+                        }
+                 memset(&ctx, 0, sizeof(ctx));
+                 memset(&tempkey[0], 0, sizeof(tempkey));
+	}
+	return ret;
+}
+
+static int get_cipher_info25(const char *requested_cipher, struct cipher_info *res)
+{
+//	char path[PATH_MAX];
+#define BUFFER_SIZE 2000
+	char buf[BUFFER_SIZE];
+	int eof=0;
+	char name[BUFFER_SIZE];
+	int minkey, maxkey;
+	int j;
+	FILE *f;
+	struct {
+		char *string;
+		int *integer;
+		const char *prefix;
+	} fields[] = {{name, NULL, "name         : "},
+		      {NULL, NULL, "module       : "},
+		      {NULL, &res->blocksize, "blocksize    : "},
+		      {NULL, &minkey, "min keysize  : "},
+		      {NULL, &maxkey, "max keysize  : "},
+		      {NULL, &res->ivsize, "ivsize       : "},
+		      {NULL, NULL, "digestsize   : "}};
+	f = fopen("/proc/crypto", "r");
+	
+	if(!f)
+		return -1;
+
+	// CryptoAPI 2.5 doesn't use <name>-<blockmode>, so cut it off
+	if(rindex(requested_cipher,'-') != NULL)
+		*rindex(requested_cipher,'-') = 0;
+
+	// Outer loop searches the requested cipher
+	while(!eof)
+	{	
+		// Inner loop parses individual crypto entries
+		while(!(eof = (fgets(buf, sizeof(buf), f) == NULL))) {
+			int i;
+			for (i = 0; i < sizeof(fields)/sizeof(fields[0]); i++) {
+				int len = strlen(fields[i].prefix);
+				if (strncmp(buf, fields[i].prefix, len) == 0) {
+					if(fields[i].string != NULL)
+					{
+						int slen = strlen(buf+len)-1;
+						strncpy(fields[i].string,buf+len,slen<BUFFER_SIZE?slen:BUFFER_SIZE);
+						fields[i].string[slen<BUFFER_SIZE?slen:BUFFER_SIZE]=0;
+					}
+					if(fields[i].integer != NULL)
+						*fields[i].integer = strtoul(&buf[len], NULL, 0);
+					break;
+				}
+			}
+
+			// No prefix found? Empty line?
+			if(buf[0] == 0xA)
+				break; 
+
+		}
+		if(strcmp(name,requested_cipher) == 0) break;	
+	}
+	if (eof) 		// Cipher not found
+		return -1;
+
+	res->key_schedule_size = 0;
+
+	// convert keysize mask
+	res->keysize_mask = 0;
+	for(j=minkey-1; j < maxkey; j++)
+		res->keysize_mask = res->keysize_mask | (1 << j);
+	return 0;
+}
+
+static int get_cipher_info24(const char *name, struct cipher_info *res)
+{
+	char path[PATH_MAX];
+	char buf[2000];
+	FILE *f;
+	struct {
+		int *out;
+		const char *prefix;
+	} fields[] = {{&res->blocksize, "blocksize:"},
+		      {&res->keysize_mask, "keysize_mask:"},
+		      {&res->ivsize, "ivsize:"},
+		      {&res->key_schedule_size, "key_schedule_size:"}};
+	snprintf(path, sizeof(path), "/proc/crypto/cipher/%s", name);
+	f = fopen(path, "r");
+	while(f && fgets(buf, sizeof(buf), f)) {
+		int i;
+		for (i = 0; i < sizeof(fields)/sizeof(fields[0]); i++) {
+			int len = strlen(fields[i].prefix);
+			if (strncmp(buf, fields[i].prefix, len) == 0) {
+				*fields[i].out = strtoul(&buf[len+1], NULL, 0);
+				break;
+			}
+		}
+		
+	}
+	if (!f) 
+		return -1;
+	return 0;
+}
+
+static int get_cipher_info(const char *name, struct cipher_info *res)
+{
+	int ret;
+	ret = get_cipher_info25(name, res);
+	if(ret == -1)
+		return get_cipher_info24(name,res);	// Fallback to 2.4.x
+	else
+		return ret;
+
+}
+
+int set_loop_passwd(struct loop_info *loopinfo, int pfd, int keysz,
+			   const char *phash_name, const char *encryption, 
+			   int fd, int ffd, char *passIterThousands, char *gpgHomeDir,
+			   char *gpgKeyFile, int passAskTwice, char *loInitValue,
+			   char *passSeedString)
+{
+	int i;
+	char *pass;
+	struct cipher_info info;
+
+	if(loopinfo->lo_encrypt_type == LO_CRYPT_NONE)
+	{
+		loopinfo->lo_encrypt_key_size = 0;
+		return 0;
+	}
+	if(loopinfo->lo_encrypt_type == LO_CRYPT_CRYPTOAPI)
+	{ // before we ask for a pwd make sure we can support that enctype
+		/* Give the kernel an opportunity to load the cipher */
+		(void) ioctl (fd, LOOP_SET_STATUS, loopinfo);
+		if (get_cipher_info(loopinfo->lo_name, &info) < 0) {
+			return 1;
+		}
+	}
+	
+	pass = sGetPass(0,0,pfd,gpgHomeDir,gpgKeyFile, passAskTwice,
+			passSeedString);
+	if(keysz == -1)		// -k auto
+	{
+		keysz = 16*8;
+		if(strlen(pass) >= 32) keysz = 24*8;
+		if(strlen(pass) >= 43) keysz = 43*8;
+		if(verbose > 1)
+			printf("auto keysiez selection %d\n",keysz);
+	}
+
+	switch (loopinfo->lo_encrypt_type) {
 	case LO_CRYPT_XOR:
-		pass = getpass (_("Password: "));
-		xstrncpy (loopinfo.lo_encrypt_key, pass, LO_KEY_SIZE);
-		loopinfo.lo_encrypt_key_size = strlen(loopinfo.lo_encrypt_key);
+          /* WARNING: xgetpass() can return massive amounts of data,
+           * not only 128 bytes like the original getpass(3) */
+		xstrncpy (loopinfo->lo_encrypt_key, pass, LO_KEY_SIZE);
+		loopinfo->lo_encrypt_key_size = strlen(loopinfo->lo_encrypt_key);
 		break;
 	case LO_CRYPT_DES:
-		pass = getpass (_("Password: "));
-		strncpy (loopinfo.lo_encrypt_key, pass, 8);
-		loopinfo.lo_encrypt_key[8] = 0;
-		loopinfo.lo_encrypt_key_size = 8;
+		printf(_("WARNING: Use of DES is depreciated.\n"));
+		strncpy (loopinfo->lo_encrypt_key, pass, 8);
+		loopinfo->lo_encrypt_key[8] = 0;
+		loopinfo->lo_encrypt_key_size = 8;
 		pass = getpass (_("Init (up to 16 hex digits): "));
 		for (i = 0; i < 16 && pass[i]; i++)
 			if (isxdigit (pass[i])) {
-				loopinfo.lo_init[i >> 3] |= (pass[i] > '9' ?
+				loopinfo->lo_init[i >> 3] |= (pass[i] > '9' ?
 				  (islower (pass[i]) ? toupper (pass[i]) :
 				   pass[i])-'A'+10 : pass[i]-'0') << (i&7) * 4;
 			} else {
@@ -267,48 +911,67 @@
 				return 1;
 			}
 		break;
+	case LO_CRYPT_CRYPTOAPI:
+		if (keysz > 0 &&
+		    !((1 << ((keysz / 8) - 1)) & info.keysize_mask)) {
+			error("The specified keysize is not supported by "
+			      "the selected cipher");
+			keysz = 0;
+		}
+
+		while (keysz <= 0 ||
+		       !((1 << ((keysz / 8) - 1)) & info.keysize_mask)) {
+			int i = 0;
+			int available = 0;
+			char keysize[200];
+			printf("Available keysizes (bits): ");
+			for (; i < 32; i++) {
+				if (info.keysize_mask & (1 << i)) {
+					printf("%d ", 8*(i+1));
+					available = 1;
+				}
+			}
+			if (!available) {
+				printf("none");
+			}
+			printf("\nKeysize: ");
+			fgets(keysize, sizeof(keysize), stdin);
+			keysz = atoi(keysize);
+		}
+		/* fall through */
+	case LO_CRYPT_FISH2:
+	case LO_CRYPT_BLOW:
+	case LO_CRYPT_IDEA:
+	case LO_CRYPT_CAST128:
+        case LO_CRYPT_SERPENT:
+        case LO_CRYPT_MARS:
+        case LO_CRYPT_RC6:
+        case LO_CRYPT_3DES:
+        case LO_CRYPT_DFC:
+        case LO_CRYPT_RIJNDAEL:
+		
+		if(keysz) 
+			loopinfo->lo_encrypt_key_size = keysz/8;
+		else
+			loopinfo->lo_encrypt_key_size = default_keysize_for_cipher(loopinfo->lo_encrypt_type);
+
+		printf("%s\n",pass?pass:"NULL");
+		memset(loopinfo->lo_encrypt_key,0,LO_KEY_SIZE);
+		prepare_passwd(pass,strlen(pass),
+				loopinfo->lo_encrypt_key,loopinfo->lo_encrypt_key_size,
+				phash_name,passIterThousands);
+
+		memset(pass, 0, strlen(pass));   /* erase original password */
+		break;
 	default:
 		fprintf (stderr,
 			 _("Don't know how to get key for encryption system %d\n"),
-			 loopinfo.lo_encrypt_type);
-		return 1;
-	}
-	if (ioctl (fd, LOOP_SET_FD, ffd) < 0) {
-		perror ("ioctl: LOOP_SET_FD");
+			 loopinfo->lo_encrypt_type);
 		return 1;
 	}
-	if (ioctl (fd, LOOP_SET_STATUS, &loopinfo) < 0) {
-		(void) ioctl (fd, LOOP_CLR_FD, 0);
-		perror ("ioctl: LOOP_SET_STATUS");
-		return 1;
-	}
-	close (fd);
-	close (ffd);
-	if (verbose > 1)
-		printf(_("set_loop(%s,%s,%d): success\n"),
-		       device, file, offset);
-	return 0;
+        return 0;
 }
 
-int 
-del_loop (const char *device) {
-	int fd;
-
-	if ((fd = open (device, O_RDONLY)) < 0) {
-		int errsv = errno;
-		fprintf(stderr, _("loop: can't delete device %s: %s\n"),
-			device, strerror (errsv));
-		return 1;
-	}
-	if (ioctl (fd, LOOP_CLR_FD, 0) < 0) {
-		perror ("ioctl: LOOP_CLR_FD");
-		return 1;
-	}
-	close (fd);
-	if (verbose > 1)
-		printf(_("del_loop(%s): success\n"), device);
-	return 0;
-}
 
 #else /* no LOOP_SET_FD defined */
 static void
@@ -320,7 +983,8 @@
 
 int
 set_loop (const char *device, const char *file, int offset,
-	  const char *encryption, int *loopro) {
+	  const char *encryption, int pfd, int *loopro, const char *phash_name,
+	  const char *blockmode) {
 	mutter();
 	return 1;
 }
@@ -349,12 +1013,60 @@
 int verbose = 0;
 static char *progname;
 
+static struct option longopts[] = {
+	{ "blockmode", 0, 0, 'b' },
+	{ "delete", 0, 0, 'd' },
+	{ "detach", 0, 0, 'd' },
+	{ "encryption", 1, 0, 'e' },
+	{ "help", 0, 0, 'h' },
+	{ "offset", 1, 0, 'o' },
+	{ "pass-fd", 1, 0, 'p' },
+	{ "phash", 1, 0, 'P' },
+	{ "verbose", 0, 0, 'v' },
+	{ "keybits", 1, 0, 'k' },
+	{ NULL, 0, 0, 0 }
+};
+
 static void
 usage(void) {
-	fprintf(stderr, _("usage:\n\
+	fprintf(stderr, 
+_("usage:\n\
   %s loop_device                                      # give info\n\
   %s -d loop_device                                   # delete\n\
-  %s [ -e encryption ] [ -o offset ] loop_device file # setup\n"),
+  %s [ options ] loop_device file                     # setup\n\
+    where options include\n\
+    --blockmode <mode>, -b <mode>\n\
+    	use specified blockmode for cipher.\n\
+    --offset <num>, -o <num>\n\
+        start at offset <num> into file.\n\
+    --pass-fd <num>, -p <num>\n\
+        read passphrase from file descriptor <num>\n\
+        instead of the terminal.\n\
+    --encryption <cipher>, -e <cipher>\n\
+        encrypt with <cipher>.\n\
+        Check /proc/crypto/cipher for available ciphers.\n\
+    --keybits <num>, -k <num>\n\
+        specify number of bits in the hashed key given\n\
+        to the cipher.  Some ciphers support several key\n\
+        sizes and might be more efficient with a smaller\n\
+        key size.  Key sizes < 128 are generally not\n\
+        recommended\n\
+    --phash <hash>, -P <hash>\n\
+        specify <hash> to use for hashing the passphrase\n\
+        (supported: rmd160old, sha256, sha384, sha512, hexconv)\n\
+    --passIter <iter>, -C <iter>\n\
+        specify numbers of thousands of iterations of AES supported hashing
+        additionally to normal password hashing\n\
+    --gpgHomeDir <homedir>, -G <homedir>\n\
+        home directory for GPG operations\n\
+    --gpgKeyFile <keyfile>, -K <keyfile>\n\
+	keyfile for GPG operations\n\
+    --passAskTwice, -T\n\
+	ask twice for the password and check for equality\n\
+    --passSeedString <seed>, -S <seed>\n\
+	prepend to passwd\n\
+    --loInit, -I\n\
+        supply additionally infos to cipher in loInit[0]\n"),
 		progname, progname, progname);
 	exit(1);
 }
